/[gentoo-x86]/eclass/elisp-common.eclass
Gentoo

Diff of /eclass/elisp-common.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.24 Revision 1.70
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.24 2007/07/10 20:14:52 ulm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.70 2010/11/29 17:07:22 ulm Exp $
4# 4#
5# Copyright 2007 Christian Faulhammer <opfer@gentoo.org>
6# Copyright 2002-2004 Matthew Kennedy <mkennedy@gentoo.org> 5# Copyright 2002-2004 Matthew Kennedy <mkennedy@gentoo.org>
6# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com>
7# Copyright 2004-2005 Mamoru Komachi <usata@gentoo.org> 7# Copyright 2004-2005 Mamoru Komachi <usata@gentoo.org>
8# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com> 8# Copyright 2007-2008 Christian Faulhammer <fauli@gentoo.org>
9# Copyright 2007 Ulrich Mueller <ulm@gentoo.org> 9# Copyright 2007-2010 Ulrich M├╝ller <ulm@gentoo.org>
10# 10#
11# This is not a real eclass, but it does provide Emacs-related installation 11# @ECLASS: elisp-common.eclass
12# utilities. 12# @MAINTAINER:
13# Feel free to contact the Emacs team through <emacs@gentoo.org> if you
14# have problems, suggestions or questions.
15# @BLURB: Emacs-related installation utilities
16# @DESCRIPTION:
13# 17#
14# USAGE:
15#
16# Usually you want to use this eclass for (optional) GNU Emacs support of 18# Usually you want to use this eclass for (optional) GNU Emacs support
17# your package. This is NOT for XEmacs! 19# of your package. This is NOT for XEmacs!
20#
18# Many of the steps here are sometimes done by the build system of your 21# Many of the steps here are sometimes done by the build system of your
19# package (especially compilation), so this is mainly for standalone elisp 22# package (especially compilation), so this is mainly for standalone
20# files you gathered from somewhere else. 23# elisp files you gathered from somewhere else.
24#
21# When relying on the emacs USE flag, you need to add 25# When relying on the emacs USE flag, you need to add
22# 26#
23# emacs? ( virtual/emacs ) 27# emacs? ( virtual/emacs )
24# 28#
25# to your DEPEND/RDEPEND line and use the functions provided here to bring 29# to your DEPEND/RDEPEND line and use the functions provided here to
26# the files to the correct locations. 30# bring the files to the correct locations.
27# 31#
32# If your package requires a minimum Emacs version, e.g. Emacs 23, then
33# the dependency should be on >=virtual/emacs-23 instead. Because the
34# user can select the Emacs executable with eselect, you should also
35# make sure that the active Emacs version is sufficient. This can be
36# tested with function elisp-need-emacs(), which would typically be
37# called from pkg_setup(), as in the following example:
38#
39# elisp-need-emacs 23 || die "Emacs version too low"
40#
41# Please note that such tests should be limited to packages that are
42# known to fail with lower Emacs versions; the standard case is to
43# depend on virtual/emacs without version.
44#
45# .SS
28# src_compile() usage: 46# src_compile() usage:
29# --------------------
30# 47#
31# An elisp file is compiled by the elisp-compile() function defined here and 48# An elisp file is compiled by the elisp-compile() function defined
32# simply takes the source files as arguments. In the case of interdependent 49# here and simply takes the source files as arguments. The case of
33# elisp files, you can use the elisp-comp() function which makes sure all 50# interdependent elisp files is also supported, since the current
51# directory is added to the load-path which makes sure that all files
34# files are loadable. 52# are loadable.
35# 53#
36# elisp-compile *.el || die "elisp-compile failed" 54# elisp-compile *.el || die
37# or
38# elisp-comp *.el || die "elisp-comp failed"
39# 55#
40# Function elisp-make-autoload-file() can be used to generate a file with 56# Function elisp-make-autoload-file() can be used to generate a file
41# autoload definitions for the lisp functions. It takes the output file name 57# with autoload definitions for the lisp functions. It takes the output
42# (default: "${PN}-autoloads.el") and a list of directories (default: working 58# file name (default: "${PN}-autoloads.el") and a list of directories
43# directory) as its arguments. Use of this function requires that the elisp 59# (default: working directory) as its arguments. Use of this function
44# source files contain magic ";;;###autoload" comments. See the Emacs Lisp 60# requires that the elisp source files contain magic ";;;###autoload"
45# Reference Manual (node "Autoload") for a detailed explanation. 61# comments. See the Emacs Lisp Reference Manual (node "Autoload") for
62# a detailed explanation.
46# 63#
64# .SS
47# src_install() usage: 65# src_install() usage:
48# --------------------
49# 66#
50# The resulting compiled files (.elc) should be put in a subdirectory of 67# The resulting compiled files (.elc) should be put in a subdirectory of
51# /usr/share/emacs/site-lisp/ which is named after the first argument 68# /usr/share/emacs/site-lisp/ which is named after the first argument
52# of elisp-install(). The following parameters are the files to be put in 69# of elisp-install(). The following parameters are the files to be put
53# that directory. Usually the subdirectory should be ${PN}, you can choose 70# in that directory. Usually the subdirectory should be ${PN}, you can
54# something else, but remember to tell elisp-site-file-install() (see below) 71# choose something else, but remember to tell elisp-site-file-install()
55# the change, as it defaults to ${PN}. 72# (see below) the change, as it defaults to ${PN}.
56# 73#
57# elisp-install ${PN} *.el *.elc || die "elisp-install failed" 74# elisp-install ${PN} *.el *.elc || die
58# 75#
59# To let the Emacs support be activated by Emacs on startup, you need 76# To let the Emacs support be activated by Emacs on startup, you need
60# to provide a site file (shipped in ${FILESDIR}) which contains the startup 77# to provide a site file (shipped in ${FILESDIR}) which contains the
61# code (have a look in the documentation of your software). Normally this 78# startup code (have a look in the documentation of your software).
62# would look like this: 79# Normally this would look like this:
63# 80#
64# ;;; csv-mode site-lisp configuration
65#
66# (add-to-list 'load-path "@SITELISP@") 81# (add-to-list 'load-path "@SITELISP@")
67# (add-to-list 'auto-mode-alist '("\\.csv\\'" . csv-mode)) 82# (add-to-list 'auto-mode-alist '("\\.csv\\'" . csv-mode))
68# (autoload 'csv-mode "csv-mode" "Major mode for editing csv files." t) 83# (autoload 'csv-mode "csv-mode" "Major mode for csv files." t)
69# 84#
70# If your Emacs support files are installed in a subdirectory of 85# If your Emacs support files are installed in a subdirectory of
71# /usr/share/emacs/site-lisp/ (which is recommended if more than one file is 86# /usr/share/emacs/site-lisp/ (which is strongly recommended), you need
72# installed), you need to extend Emacs' load-path as shown in the first 87# to extend Emacs' load-path as shown in the first non-comment line.
73# non-comment. The elisp-site-file-install() function of this eclass will 88# The elisp-site-file-install() function of this eclass will replace
74# replace "@SITELISP@" by the actual path. 89# "@SITELISP@" and "@SITEETC@" by the actual paths.
90#
75# The next line tells Emacs to load the mode opening a file ending with 91# The next line tells Emacs to load the mode opening a file ending
76# ".csv" and load functions depending on the context and needed features. 92# with ".csv" and load functions depending on the context and needed
77# Be careful though. Commands as "load-library" or "require" bloat the 93# features. Be careful though. Commands as "load-library" or "require"
78# editor as they are loaded on every startup. When having a lot of Emacs 94# bloat the editor as they are loaded on every startup. When having
79# support files, users may be annoyed by the start-up time. Also avoid 95# many Emacs support files, users may be annoyed by the start-up time.
80# keybindings as they might interfere with the user's settings. Give a hint 96# Also avoid keybindings as they might interfere with the user's
81# in pkg_postinst(), which should be enough. 97# settings. Give a hint in pkg_postinst(), which should be enough.
82# The naming scheme for this site file is "[0-9][0-9]*-gentoo.el", where the 98#
83# two digits at the beginning define the loading order. So if you depend on 99# The naming scheme for this site-init file matches the shell pattern
84# another Emacs package, your site file's number must be higher! 100# "[1-8][0-9]*-gentoo*.el", where the two digits at the beginning define
101# the loading order (numbers below 10 or above 89 are reserved for
102# internal use). So if your initialisation depends on another Emacs
103# package, your site file's number must be higher! If there are no such
104# interdependencies then the number should be 50. Otherwise, numbers
105# divisible by 10 are preferred.
106#
85# Best practice is to define a SITEFILE variable in the global scope of your 107# Best practice is to define a SITEFILE variable in the global scope of
86# ebuild (right after DEPEND e.g.): 108# your ebuild (e.g., right after S or RDEPEND):
87# 109#
88# SITEFILE=50${PN}-gentoo.el 110# SITEFILE="50${PN}-gentoo.el"
89# 111#
90# Which is then installed by 112# Which is then installed by
91# 113#
92# elisp-site-file-install "${FILESDIR}/${SITEFILE}" 114# elisp-site-file-install "${FILESDIR}/${SITEFILE}" || die
93# 115#
116# in src_install(). Any characters after the "-gentoo" part and before
117# the extension will be stripped from the destination file's name.
118# For example, a file "50${PN}-gentoo-${PV}.el" will be installed as
94# in src_install(). If your subdirectory is not named ${PN}, give the 119# "50${PN}-gentoo.el". If your subdirectory is not named ${PN}, give
95# differing name as second argument. 120# the differing name as second argument.
96# 121#
122# .SS
97# pkg_postinst() / pkg_postrm() usage: 123# pkg_postinst() / pkg_postrm() usage:
98# ------------------------------------
99# 124#
100# After that you need to recreate the start-up file of Emacs after emerging 125# After that you need to recreate the start-up file of Emacs after
101# and unmerging by using 126# emerging and unmerging by using
102# 127#
103# pkg_postinst() { 128# pkg_postinst() {
104# elisp-site-regen 129# elisp-site-regen
105# } 130# }
106# 131#
107# pkg_postrm() { 132# pkg_postrm() {
108# elisp-site-regen 133# elisp-site-regen
109# } 134# }
110# 135#
111# When having optional Emacs support, you should prepend "use emacs &&" to 136# When having optional Emacs support, you should prepend "use emacs &&"
112# above calls of elisp-site-regen(). Don't use "has_version virtual/emacs"! 137# to above calls of elisp-site-regen().
113# When unmerging the state of the USE flag emacs is taken from the package 138# Don't use "has_version virtual/emacs"! When unmerging the state of
114# database and not from the environment, so it is no problem when you unset 139# the emacs USE flag is taken from the package database and not from the
140# environment, so it is no problem when you unset USE=emacs between
115# USE=emacs between merge und unmerge of a package. 141# merge and unmerge of a package.
116#
117# Miscellaneous functions:
118# ------------------------
119#
120# elisp-emacs-version() outputs the version of the currently active Emacs.
121#
122# As always: Feel free to contact Emacs team through emacs@gentoo.org if you
123# have problems, suggestions or questions.
124 142
143# @ECLASS-VARIABLE: SITELISP
144# @DESCRIPTION:
145# Directory where packages install Emacs Lisp files.
125SITELISP=/usr/share/emacs/site-lisp 146SITELISP=/usr/share/emacs/site-lisp
126 147
148# @ECLASS-VARIABLE: SITEETC
149# @DESCRIPTION:
150# Directory where packages install miscellaneous (not Lisp) files.
151SITEETC=/usr/share/emacs/etc
152
153# @ECLASS-VARIABLE: EMACS
154# @DESCRIPTION:
155# Path of Emacs executable.
156EMACS=${EPREFIX}/usr/bin/emacs
157
158# @ECLASS-VARIABLE: EMACSFLAGS
159# @DESCRIPTION:
160# Flags for executing Emacs in batch mode.
161# These work for Emacs versions 18-23, so don't change them.
162EMACSFLAGS="-batch -q --no-site-file"
163
164# @ECLASS-VARIABLE: BYTECOMPFLAGS
165# @DESCRIPTION:
166# Emacs flags used for byte-compilation in elisp-compile().
167BYTECOMPFLAGS="-L ."
168
169# @FUNCTION: elisp-emacs-version
170# @DESCRIPTION:
171# Output version of currently active Emacs.
172
173elisp-emacs-version() {
174 # The following will work for at least versions 18-23.
175 echo "(princ emacs-version)" >"${T}"/emacs-version.el
176 ${EMACS} ${EMACSFLAGS} -l "${T}"/emacs-version.el
177 rm -f "${T}"/emacs-version.el
178}
179
180# @FUNCTION: elisp-need-emacs
181# @USAGE: <version>
182# @RETURN: 0 if true, 1 otherwise
183# @DESCRIPTION:
184# Test if the eselected Emacs version is at least the major version
185# specified as argument.
186
187elisp-need-emacs() {
188 local need_emacs=$1
189 local have_emacs=$(elisp-emacs-version)
190 einfo "Emacs version: ${have_emacs}"
191 if ! [[ ${have_emacs%%.*} -ge ${need_emacs%%.*} ]]; then
192 eerror "This package needs at least Emacs ${need_emacs%%.*}."
193 eerror "Use \"eselect emacs\" to select the active version."
194 return 1
195 fi
196 return 0
197}
198
199# @FUNCTION: elisp-compile
200# @USAGE: <list of elisp files>
201# @DESCRIPTION:
202# Byte-compile Emacs Lisp files.
203#
204# This function uses GNU Emacs to byte-compile all ".el" specified by
205# its arguments. The resulting byte-code (".elc") files are placed in
206# the same directory as their corresponding source file.
207#
208# The current directory is added to the load-path. This will ensure
209# that interdependent Emacs Lisp files are visible between themselves,
210# in case they require or load one another.
211
127elisp-compile() { 212elisp-compile() {
128 einfo "Compiling GNU Emacs Elisp files ..." 213 ebegin "Compiling GNU Emacs Elisp files"
129 /usr/bin/emacs -batch -q --no-site-file -f batch-byte-compile $* 214 ${EMACS} ${EMACSFLAGS} ${BYTECOMPFLAGS} -f batch-byte-compile "$@"
215 eend $? "elisp-compile: batch-byte-compile failed"
130} 216}
131 217
132elisp-emacs-version() { 218# @FUNCTION: elisp-make-autoload-file
133 # Output version of currently active Emacs. 219# @USAGE: [output file] [list of directories]
134 # The following will work for at least versions 18-22. 220# @DESCRIPTION:
135 echo "(princ emacs-version)" >"${T}"/emacs-version.el 221# Generate a file with autoload definitions for the lisp functions.
136 /usr/bin/emacs -batch -q --no-site-file -l "${T}"/emacs-version.el
137}
138 222
139elisp-make-autoload-file () { 223elisp-make-autoload-file() {
140 local f="${1:-${PN}-autoloads.el}" 224 local f="${1:-${PN}-autoloads.el}" null="" page=$'\f'
141 shift 225 shift
142 einfo "Generating autoload file for GNU Emacs ..." 226 ebegin "Generating autoload file for GNU Emacs"
143 227
144 sed 's/^FF/\f/' >"${f}" <<-EOF 228 cat >"${f}" <<-EOF
145 ;;; ${f##*/} --- autoloads for ${P} 229 ;;; ${f##*/} --- autoloads for ${PN}
146 230
147 ;;; Commentary: 231 ;;; Commentary:
148 ;; Automatically generated by elisp-common.eclass 232 ;; Automatically generated by elisp-common.eclass
149 ;; DO NOT EDIT THIS FILE 233 ;; DO NOT EDIT THIS FILE
150 234
151 ;;; Code: 235 ;;; Code:
152 FF 236 ${page}
153 ;; Local Variables: 237 ;; Local ${null}Variables:
154 ;; version-control: never 238 ;; version-control: never
155 ;; no-byte-compile: t 239 ;; no-byte-compile: t
156 ;; no-update-autoloads: t 240 ;; no-update-autoloads: t
157 ;; End: 241 ;; End:
242
158 ;;; ${f##*/} ends here 243 ;;; ${f##*/} ends here
159 EOF 244 EOF
160 245
161 /usr/bin/emacs -batch -q --no-site-file \ 246 ${EMACS} ${EMACSFLAGS} \
162 --eval "(setq make-backup-files nil)" \ 247 --eval "(setq make-backup-files nil)" \
163 --eval "(setq generated-autoload-file (expand-file-name \"${f}\"))" \ 248 --eval "(setq generated-autoload-file (expand-file-name \"${f}\"))" \
164 -f batch-update-autoloads "${@-.}" 249 -f batch-update-autoloads "${@-.}"
250
251 eend $? "elisp-make-autoload-file: batch-update-autoloads failed"
165} 252}
253
254# @FUNCTION: elisp-install
255# @USAGE: <subdirectory> <list of files>
256# @DESCRIPTION:
257# Install files in SITELISP directory.
166 258
167elisp-install() { 259elisp-install() {
168 local subdir=$1 260 local subdir="$1"
169 einfo "Installing Elisp files for GNU Emacs support ..."
170 dodir "${SITELISP}/${subdir}"
171 insinto "${SITELISP}/${subdir}"
172 shift 261 shift
262 ebegin "Installing Elisp files for GNU Emacs support"
263 ( # subshell to avoid pollution of calling environment
264 insinto "${SITELISP}/${subdir}"
173 doins $@ 265 doins "$@"
266 )
267 eend $? "elisp-install: doins failed"
174} 268}
269
270# @FUNCTION: elisp-site-file-install
271# @USAGE: <site-init file> [subdirectory]
272# @DESCRIPTION:
273# Install Emacs site-init file in SITELISP directory. Automatically
274# inserts a standard comment header with the name of the package (unless
275# it is already present). Tokens @SITELISP@ and @SITEETC@ are replaced
276# by the path to the package's subdirectory in SITELISP and SITEETC,
277# respectively.
175 278
176elisp-site-file-install() { 279elisp-site-file-install() {
177 local sitefile=$1 my_pn=${2:-${PN}} 280 local sf="${1##*/}" my_pn="${2:-${PN}}" ret
281 local header=";;; ${PN} site-lisp configuration"
282
283 [[ ${sf} == [0-9][0-9]*-gentoo*.el ]] \
284 || ewarn "elisp-site-file-install: bad name of site-init file"
285 sf="${T}/${sf/%-gentoo*.el/-gentoo.el}"
178 einfo "Installing site initialisation file for GNU Emacs ..." 286 ebegin "Installing site initialisation file for GNU Emacs"
179 pushd "${S}" 287 [[ $1 = ${sf} ]] || cp "$1" "${sf}"
180 cp ${sitefile} "${T}" 288 sed -i -e "1{:x;/^\$/{n;bx;};/^;.*${PN}/I!s:^:${header}\n\n:;1s:^:\n:;}" \
181 sed -i "s:@SITELISP@:${SITELISP}/${my_pn}:g" "${T}/$(basename ${sitefile})" 289 -e "s:@SITELISP@:${EPREFIX}${SITELISP}/${my_pn}:g" \
182 insinto ${SITELISP} 290 -e "s:@SITEETC@:${EPREFIX}${SITEETC}/${my_pn}:g;\$q" "${sf}"
183 doins "${T}/$(basename ${sitefile})" || die "failed to install site file" 291 ( # subshell to avoid pollution of calling environment
184 popd 292 insinto "${SITELISP}/site-gentoo.d"
293 doins "${sf}"
294 )
295 ret=$?
296 rm -f "${sf}"
297 eend ${ret} "elisp-site-file-install: doins failed"
185} 298}
299
300# @FUNCTION: elisp-site-regen
301# @DESCRIPTION:
302# Regenerate the site-gentoo.el file, based on packages' site
303# initialisation files in the /usr/share/emacs/site-lisp/site-gentoo.d/
304# directory.
305#
306# Note: Before December 2007, site initialisation files were installed
307# in /usr/share/emacs/site-lisp/. For backwards compatibility, this
308# location is still supported when generating site-gentoo.el.
186 309
187elisp-site-regen() { 310elisp-site-regen() {
188 local sflist sf line 311 local sitelisp=${ROOT}${EPREFIX}${SITELISP}
312 local sf i line null="" page=$'\f'
313 local -a sflist
189 314
190 einfo "Regenerating ${SITELISP}/site-gentoo.el ..." 315 if [ ! -d "${sitelisp}" ]; then
316 eerror "elisp-site-regen: Directory ${sitelisp} does not exist"
317 return 1
318 fi
319
320 if [ ! -d "${T}" ]; then
321 eerror "elisp-site-regen: Temporary directory ${T} does not exist"
322 return 1
323 fi
324
325 einfon "Regenerating site-gentoo.el for GNU Emacs (${EBUILD_PHASE}) ..."
326
327 # Until January 2009, elisp-common.eclass sometimes created an
328 # auxiliary file for backwards compatibility. Remove any such file.
329 rm -f "${sitelisp}"/00site-gentoo.el
330
331 for sf in "${sitelisp}"/[0-9][0-9]*-gentoo.el \
332 "${sitelisp}"/site-gentoo.d/[0-9][0-9]*.el
333 do
334 [ -r "${sf}" ] || continue
335 # sort files by their basename. straight insertion sort.
336 for ((i=${#sflist[@]}; i>0; i--)); do
337 [[ ${sf##*/} < ${sflist[i-1]##*/} ]] || break
338 sflist[i]=${sflist[i-1]}
339 done
340 sflist[i]=${sf}
341 done
342
191 cat <<-EOF >"${T}"/site-gentoo.el 343 cat <<-EOF >"${T}"/site-gentoo.el
192 ;;; site-gentoo.el --- site initialisation for Gentoo-installed packages 344 ;;; site-gentoo.el --- site initialisation for Gentoo-installed packages
193 345
194 ;;; Commentary: 346 ;;; Commentary:
195 ;; Automatically generated by elisp-common.eclass 347 ;; Automatically generated by elisp-common.eclass
196 ;; DO NOT EDIT THIS FILE 348 ;; DO NOT EDIT THIS FILE
197 349
198 ;;; Code: 350 ;;; Code:
199 EOF 351 EOF
200 352 # Use sed instead of cat here, since files may miss a trailing newline.
201 for sf in "${ROOT}${SITELISP}"/[0-9][0-9]*-gentoo.el 353 sed '$q' "${sflist[@]}" </dev/null >>"${T}"/site-gentoo.el
202 do
203 [ -r "${sf}" ] || continue
204 sflist="${sflist} $(basename "${sf}")"
205 cat "${sf}" >>"${T}"/site-gentoo.el
206 done
207
208 cat <<-EOF >>"${T}"/site-gentoo.el 354 cat <<-EOF >>"${T}"/site-gentoo.el
355
356 ${page}
357 (provide 'site-gentoo)
358
359 ;; Local ${null}Variables:
360 ;; no-byte-compile: t
361 ;; buffer-read-only: t
362 ;; End:
209 363
210 ;;; site-gentoo.el ends here 364 ;;; site-gentoo.el ends here
211 EOF 365 EOF
212 366
213 if cmp -s "${ROOT}${SITELISP}"/site-gentoo.el "${T}"/site-gentoo.el; then 367 if cmp -s "${sitelisp}"/site-gentoo.el "${T}"/site-gentoo.el; then
214 # This prevents outputting unnecessary text when there 368 # This prevents outputting unnecessary text when there
215 # was actually no change 369 # was actually no change.
216 # A case is a remerge where we have doubled output 370 # A case is a remerge where we have doubled output.
371 rm -f "${T}"/site-gentoo.el
217 einfo "... no changes" 372 echo " no changes."
218 else 373 else
219 mv "${T}"/site-gentoo.el "${ROOT}${SITELISP}"/site-gentoo.el 374 mv "${T}"/site-gentoo.el "${sitelisp}"/site-gentoo.el
220 einfo ""
221 for sf in ${sflist}; do
222 einfo " Adding ${sf} ..."
223 done
224 while read line; do einfo "${line}"; done <<EOF
225
226All site initialisation for Gentoo-installed packages is now added to
227/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer
228managed by Gentoo. You are responsible for all maintenance of
229site-start.el if there is such a file.
230
231In order for this site initialisation to be loaded for all users
232automatically, as was done previously, you can add a line like this:
233
234 (load "/usr/share/emacs/site-lisp/site-gentoo" nil t)
235
236to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line
237can be added by individual users to their initialisation files, or for
238greater flexibility, users can select which of the package-specific
239initialisation files in /usr/share/emacs/site-lisp to load.
240EOF
241 echo 375 echo
376 case ${#sflist[@]} in
377 0) ewarn "... Huh? No site initialisation files found." ;;
378 1) einfo "... ${#sflist[@]} site initialisation file included." ;;
379 *) einfo "... ${#sflist[@]} site initialisation files included." ;;
380 esac
242 fi 381 fi
243}
244 382
245# The following Emacs Lisp compilation routine was originally taken from 383 return 0
246# GNU autotools.
247
248elisp-comp() {
249 # Copyright 1995 Free Software Foundation, Inc.
250 # Fran├žois Pinard <pinard@iro.umontreal.ca>, 1995.
251 # This script byte-compiles all `.el' files which are part of its
252 # arguments, using GNU Emacs, and put the resulting `.elc' files into
253 # the current directory, so disregarding the original directories used
254 # in `.el' arguments.
255 #
256 # This script manages in such a way that all Emacs LISP files to
257 # be compiled are made visible between themselves, in the event
258 # they require or load-library one another.
259
260 test $# -gt 0 || return 1
261
262 if test -z "${EMACS}" || test "${EMACS}" = "t"; then
263 # Value of "t" means we are running in a shell under Emacs.
264 # Just assume Emacs is called "emacs".
265 EMACS=/usr/bin/emacs
266 fi
267 einfo "Compiling GNU Emacs Elisp files ..."
268
269 tempdir=elc.$$
270 mkdir ${tempdir}
271 cp $* ${tempdir}
272 pushd ${tempdir}
273
274 echo "(add-to-list 'load-path \"../\")" > script
275 ${EMACS} -batch -q --no-site-file --no-init-file -l script \
276 -f batch-byte-compile *.el
277 local status=$?
278 mv *.elc ..
279
280 popd
281 rm -fr ${tempdir}
282 return ${status}
283} 384}

Legend:
Removed from v.1.24  
changed lines
  Added in v.1.70

  ViewVC Help
Powered by ViewVC 1.1.20